> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/spark/sparkcollateralswitch.md).

# SparkCollateralSwitch

### Description

Switch if you'll use tokens for collateral on spark for a market

### Action ID

`0x85f16e59`

### SDK Action

```ts
const sparkCollateralSwitchAction = new dfs.actions.spark.SparkCollateralSwitchAction(
    useDefaultMarket,
    market,
    arrayLength,
    assetIds,
    useAsCollateral
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param arrayLength Length of the assetIds and useAsCollateral arrays
    /// @param useDefaultMarket Whether to use the default market
    /// @param assetIds Array of asset ids
    /// @param useAsCollateral Array of booleans indicating if the asset should be used as collateral
    /// @param market Address of the market to switch collateral for
    struct Params {
        uint8 arrayLength;
        bool useDefaultMarket;
        uint16[] assetIds;
        bool[] useAsCollateral;
        address market;
    }
```

### Return Value

```solidity
return bytes32(0);
```

### Events and Logs

```solidity
emit ActionEvent("SparkCollateralSwitch", logData);
logger.logActionDirectEvent("SparkCollateralSwitch", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/spark/sparkcollateralswitch.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
